﻿#This script reads lines on a com port for X seconds  
# usage:  
# - configure the script parameters  
# - run it using powershell from the command line  
#   to send the results to a text file, redirects the pipeline to a text file like this:  
#   type "powershell" + "enter"  
#   then type ".\ReadCOMPort.ps1 > c:\temp\COMXPortData.txt" + "enter"  
#  
# -- PARAMETERS --  
$DelaySeconds=15  
$PORT='COM26'  
$BAUDRATE=115200  
$Parity=[System.IO.Ports.Parity]::None # System.IO.Ports.Parity  
$dataBits=8  
$StopBits=[System.IO.Ports.StopBits]::one # System.IO.Ports.StopBits  
# END PARAMETERS ---------------------------------  

# ADD TIMESTAMP ----------------------------------
#filter timestamp {"$(Get-Date -Format ss.fff),$_"}
# END TIMESTAMP ----------------------------------

$period = [timespan]::FromSeconds($DelaySeconds)  
$port= new-Object System.IO.Ports.SerialPort $PORT,$BAUDRATE,$Parity,$dataBits,$StopBits  
$port.Open()  
  
  
# Debug  
#Write-Output 'PORT OPENED'  
$StartTime = Get-Date  
  
  

# Gets the data from the com port for the specified interval  
while ((Get-Date) - $StartTime -lt $period) {  
  $message=$port.ReadLine()  
  Write-Output $message #| timestamp
}  
$port.Close()  
  
  
#Debug  
#Write-Output 'PORT CLOSED'  
#--